'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = createFeatureRoute;

var _optionsDefaults = require('./optionsDefaults');

var _optionsDefaults2 = _interopRequireDefault(_optionsDefaults);

var _wrapRoute = require('./wrapRoute');

var _wrapRoute2 = _interopRequireDefault(_wrapRoute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelPluginFlowReactPropTypes_proptype_Store = require('redux').babelPluginFlowReactPropTypes_proptype_Store || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_PlainRoute = require('react-router').babelPluginFlowReactPropTypes_proptype_PlainRoute || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_FeatureStates = require('redux-features').babelPluginFlowReactPropTypes_proptype_FeatureStates || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Features = require('redux-features').babelPluginFlowReactPropTypes_proptype_Features || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_FeatureStateAlert = require('./index').babelPluginFlowReactPropTypes_proptype_FeatureStateAlert || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_GetRoute = require('./wrapRoute').babelPluginFlowReactPropTypes_proptype_GetRoute || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_FirstOptions = {
  isServer: require('prop-types').bool,
  getFeatureStates: require('prop-types').func,
  getFeatures: require('prop-types').func,
  rematchRoutes: require('prop-types').func,
  FeatureStateAlert: typeof _FeatureStateAlert === 'function' ? require('prop-types').instanceOf(_FeatureStateAlert) : require('prop-types').any
};
if (typeof exports !== 'undefined') Object.defineProperty(exports, 'babelPluginFlowReactPropTypes_proptype_FirstOptions', {
  value: babelPluginFlowReactPropTypes_proptype_FirstOptions,
  configurable: true
});
var babelPluginFlowReactPropTypes_proptype_SecondOptions = {
  store: typeof babelPluginFlowReactPropTypes_proptype_Store === 'function' ? babelPluginFlowReactPropTypes_proptype_Store.isRequired ? babelPluginFlowReactPropTypes_proptype_Store.isRequired : babelPluginFlowReactPropTypes_proptype_Store : require('prop-types').shape(babelPluginFlowReactPropTypes_proptype_Store).isRequired,
  featureId: require('prop-types').string.isRequired,
  featureName: require('prop-types').string.isRequired,
  getRoute: typeof babelPluginFlowReactPropTypes_proptype_GetRoute === 'function' ? babelPluginFlowReactPropTypes_proptype_GetRoute.isRequired ? babelPluginFlowReactPropTypes_proptype_GetRoute.isRequired : babelPluginFlowReactPropTypes_proptype_GetRoute : require('prop-types').shape(babelPluginFlowReactPropTypes_proptype_GetRoute).isRequired
};
if (typeof exports !== 'undefined') Object.defineProperty(exports, 'babelPluginFlowReactPropTypes_proptype_SecondOptions', {
  value: babelPluginFlowReactPropTypes_proptype_SecondOptions,
  configurable: true
});
function createFeatureRoute(firstOptions) {
  firstOptions = (0, _optionsDefaults2.default)(firstOptions);
  var _firstOptions = firstOptions,
      getFeatures = _firstOptions.getFeatures;

  return function (secondOptions) {
    var store = secondOptions.store,
        featureId = secondOptions.featureId,
        featureName = secondOptions.featureName,
        getRoute = secondOptions.getRoute,
        props = (0, _objectWithoutProperties3.default)(secondOptions, ['store', 'featureId', 'featureName', 'getRoute']);

    var feature = getFeatures(store.getState())[featureId];
    var route = feature && getRoute(feature) || {};
    if (typeof route === 'function') route = route(store);
    return (0, _wrapRoute2.default)((0, _extends3.default)({}, firstOptions, {
      store: store,
      featureId: featureId,
      featureName: featureName,
      getRoute: getRoute,
      route: (0, _extends3.default)({}, route, props)
    }));
  };
}